/* This file is part of tctswitch
   Copyright © 2007 Nokia Corporation and/or its subsidiary(-ies).
   Contact: Petr Baranov petr.baranov@nokia.com

  This program is free software: you can redistribute it and/or modify it under the terms
  of the GNU (Lesser) General Public License as published by the Free Software Foundation,
  version 2 of the License.This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE. See the GNU (Lesser) General Public License for more details.
  You should have received a copy of the GNU (Lesser) General Public License along with this program.
  If not, see <http://www.gnu.org/licenses/>
*/
#include "commandhandler.h"
#include <QDebug>
#include <QProcess>

CommandHandler::CommandHandler(QObject *parent) :
    QObject(parent)
{
}

void CommandHandler::update(){
    QString result;
    QString prefix="/usr/yari/";

    if(bitmap & (1<<SENSORS)){
        result += prefix+"libQtSensors.so.1:"+prefix+"libQtSensors.so.1.2:"+prefix+"libQtSensors.so.1.2.0:";
    }
    if(bitmap & (1<<MULTIMEDIA)){
        result += prefix+"libQtSensors.so.1:"+prefix+"libQtSensors.so.1.2:"+prefix+"libQtSensors.so.1.2.0:";
    }
    if(bitmap & (1<<LOCATION)){
        result += prefix+"libQtLocation.so.1:"+prefix+"libQtLocation.so.1.2:"+prefix+"libQtLocation.so.1.2.0:";
    }
    if(bitmap & (1<<ORGANIZER)){
        result += prefix+"libQtOrganizer.so.1:"+prefix+"libQtOrganizer.so.1.2:"+prefix+"libQtOrganizer.so.1.2.0:";
    }
    if(bitmap & (1<<CONTACTS)){
        result += prefix+"libQtContacts.so.1:"+prefix+"libQtContacts.so.1.2:"+prefix+"libQtContacts.so.1.2.0:";
    }
    if(bitmap & (1<<SYSINFO)){
        result += prefix+"libQtSystemInfo.so.1:"+prefix+"libQtSystemInfo.so.1.2:"+prefix+"libQtSystemInfo.so.1.2.0:";
    }
    if(bitmap & (1<<FEEDBACK)){
        result += prefix+"libQtFeedback.so.1:"+prefix+"libQtFeedback.so.1.2:"+prefix+"libQtFeedback.so.1.2.0:";
    }
    clean("LD_PRELOAD");
    if(!result.isEmpty()){
                result +=prefix+"libQtMobilitySimulator.so.1:"+prefix+"libQtMobilitySimulator.so.1.2:"+prefix+"libQtMobilitySimulator.so.1.2.0";
                set("LD_PRELOAD",result);
    }
}

void CommandHandler::clean(QString str){
    QProcess clean;
    clean.start("sed",QStringList()<<"-i"<<"/"+str+"/d"<<"/home/developer/.profile");
    clean.waitForFinished();
}

void CommandHandler::set(QString var, QString val){
    QProcess update;
    update.start("sed",QStringList()<<"-i"<<"$a export "+var+"="+val<<"/home/developer/.profile");
    update.waitForFinished();
}
