/* This file is part of tctswitch
   Copyright © 2007 Nokia Corporation and/or its subsidiary(-ies).
   Contact: Petr Baranov petr.baranov@nokia.com

  This program is free software: you can redistribute it and/or modify it under the terms
  of the GNU (Lesser) General Public License as published by the Free Software Foundation,
  version 2 of the License.This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE. See the GNU (Lesser) General Public License for more details.
  You should have received a copy of the GNU (Lesser) General Public License along with this program.
  If not, see <http://www.gnu.org/licenses/>
*/

#ifndef COMMANDHANDLER_H
#define COMMANDHANDLER_H

#include <QObject>

enum Libs{
    SENSORS,
    ORGANIZER,
    MULTIMEDIA,
    FEEDBACK,
    LOCATION=5,
    SYSINFO=6,
    CONTACTS=7
};

class CommandHandler : public QObject
{
    Q_OBJECT
public:
    explicit CommandHandler(QObject *parent = 0);

signals:

public slots:
   void setSensors(bool enabled){enabled?bitmap|=1<<SENSORS:bitmap&= ~(1<<SENSORS);};
   void setOrganizer(bool enabled){enabled?bitmap|=1<<ORGANIZER:bitmap&= ~(1<<ORGANIZER);};
   void setMultimedia(bool enabled){enabled?bitmap|=1<<MULTIMEDIA:bitmap&= ~(1<<MULTIMEDIA);};
   void setFeedback(bool enabled){enabled?bitmap|=1<<FEEDBACK:bitmap&= ~(1<<FEEDBACK);};
   void setLocation(bool enabled){enabled?bitmap|=1<<LOCATION:bitmap&= ~(1<<LOCATION);};
   void setSystemInfo(bool enabled){enabled?bitmap|=1<<SYSINFO:bitmap&= ~(1<<SYSINFO);};
   void setContacts(bool enabled){enabled?bitmap|=1<<CONTACTS:bitmap&= ~(1<<CONTACTS);};
   void update();
   void clean(QString);
   void set(QString,QString);
private:
   int bitmap;

};

#endif // COMMANDHANDLER_H
